/* 
 *  gs_ac.c - command line system administration utility.
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include "config.h"
#include "getstatd.h"



extern	char * optarg;
extern	int	opterr;

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

int main( int argc, char *argv[] ){

	   int I;
	   int opt;

    opterr = 0;
    while ((opt = getopt(argc, argv, "hmvf:u:p:")) != EOF){
	switch(opt){
	    case 'v':
		    printf("gs_adduser for getstatd %s. Copyright (c) Maxim Chirkov\n\n", GETSTATD_VER);
		    return 1;
	    case 'm':
		    md5_flag = 1;
		    break;
	    case 'f':
	    	    if (optarg != 0) {
			pwd_name = (char *) my_malloc(strlen(optarg)+1);
	        	if (pwd_name == NULL){
			    return 3;
			}
			strcpy(pwd_name, optarg);
			break;
	    	    }
	    case 'u':
	    	    if (optarg != 0) {
			user_name = (char *) my_malloc(strlen(optarg)+1);
	        	if (user_name == NULL){
			    return 3;
			}
			strcpy(user_name, optarg);
			break;
	    	    }
	    case 'p':
	    	    if (optarg != 0) {
			user_pwd = (char *) my_malloc(strlen(optarg)+1);
	        	if (user_pwd == NULL){
			    return 3;
			}
			strcpy(user_pwd, optarg);
			break;
	    	    }
	    case '?':
	    	    fprintf(stderr, "Invalid option or missing parameter.\n\n");
	    case 'h':
		    printf("Usage: %s [-f pwd_file] [-u username] [-p password] [-m] [-h]\n\n", argv[0]);
		    printf("-f file   - Location of getstatd config file.\n");
		    printf("-w file   - Location of wtmp file.\n");
		    printf("-u user   - .\n");
		    printf("-l [lines]- .\n");
		    printf("-p        - .\n");
		    printf("-t        - .\n");
		    printf("-s data   - .\n");
		    printf("-e data   - .\n");
		    printf("-M range  - .\n");
		    printf("-H        - .\n");
		    printf("-v   - .\n");
		    printf("-h   - .\n");
		    return 2;
	}
    
    }
}
  


