/* 
 *  includes.c - Actions for includes.
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include "getstatd.h"

char cur_ip[BUF_SIZE+1];
char user_name[BUF_SIZE+1];
int	speed_flag = 0;

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

int isagain(simple_time_period * tp, int num){
	int I;

    for (I = 0; I < num; I++){
	if (strncmp(tp[I].name, tp[num].name, PN_SIZE) == 0){
	    return 1;
	}
    }
    return 0;
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void get_tp_data(simple_time_period * tp, int num, long * ptime, float * price){
	int I;

    *ptime = 0;
    *price = 0;
    for (I = 0; I < n_timeperiods; I++){
	if (strncmp(tp[I].name, tp[num].name, PN_SIZE) == 0){
	   *ptime += tp[I].all_time;
	   *price += (tp[I].all_time / 60) * tp[I].price;
	}
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print "who is online" statistic */

void inc_who ( void ){

    prints("LOGIN      TTY    (IP ADDRESS) SUM TIME       FROM             LOGIN TIME\t\t     CURRENT TIME\n");
    who_is_on();
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

/* Print terminal statistic */


void inc_line ( void ){
	tty_list * point_tty;
	char buff[BUF_SIZE+1];
	char tmp_buff[BUF_SIZE+1];
	long	cnt_tmp = 0;
	long	ptime;
	float 	price, sum_price;
	int I, tty_num=0;

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t,user_name, CMD_LINESTAT);
    }
    sprintf(buff," TTY       ALL\t\tCONNECTS  ");

    for (I = 0; I < n_timeperiods; I++){
	if ( isagain(def_tp, I) == 0) {
	    snprintf(tmp_buff, BUF_SIZE, "%s%15s\t  ", buff, def_tp[I].name);
	    strncpy(buff, tmp_buff, BUF_SIZE);

	}
    }
    snprintf(tmp_buff, BUF_SIZE, "%sSUM PRICE\n", buff);
    strncpy(buff, tmp_buff, BUF_SIZE);
    prints(buff);
    point_tty = all_ttylist;
    while (point_tty != NULL){
		snprintf(buff,BUF_SIZE,"%-6.6s    |%-2.2d:%-2.2d  %-5.1ld| %-4.4ld",
			 point_tty->tty_name,
			 (point_tty->all_time/ 3600),(point_tty->all_time/60) % 60,
			 point_tty->all_time/60, point_tty->all_count);
		sum_price = 0;
		for (I = 0; I < n_timeperiods; I++){
		    if ( isagain(def_tp, I ) == 0) {
			get_tp_data(point_tty->tp, I, &ptime, &price);
			sum_price += price;
			snprintf(tmp_buff, BUF_SIZE, "%s\t|%-2.2d:%-2.2d  %-5.1ld %.2f", 
			         buff, ptime/ 3600,(ptime/60) % 60, ptime/60, price);
			strncpy(buff, tmp_buff, BUF_SIZE);

		    }
		}
		snprintf(tmp_buff, BUF_SIZE, "%s\t|%.2f\n", buff, sum_price);
		strncpy(buff, tmp_buff, BUF_SIZE);
		prints(buff);        
		tty_num++;
		point_tty=point_tty->next;
    }
    
    prints("\nACTIVE TTYS -  PERCENTS\n");        

    for (I=0; I < tty_num; I++ ){
	cnt_tmp +=coop_tty[I];
    }
    
    for (I=0; I < tty_num; I++ ){
	snprintf(buff,BUF_SIZE,"%-5d       -  %.2f\n",I+1,(coop_tty[I]*100.0)/cnt_tmp);	
    	prints(buff);        
    }

}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print last users statistic */

void inc_last ( void ){

#ifdef HAVE_ADDR_IN_UTMP
    prints("NUM, LOGIN     TTY      ONLINE\t\t\tFROM\t   IP\t\tLOGIN TIME\t\tLOGOUT TIME\n");
#else
    prints("NUM, LOGIN     TTY      ONLINE\t\t\tFROM\t\tLOGIN TIME\t\tLOGOUT TIME\n");
#endif
	speed_flag++;
	print_time_stat(start_t,end_t,user_name, CMD_LASTSTAT);
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print general users statistic */

void inc_users ( void ){
	user_list * point_user;
	char buff[BUF_SIZE+1];
	char tmp_buff[BUF_SIZE+1];
	long	ptime;
	float 	price, sum_price;
	int I;

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ALLUSERSTAT);
    }
    sprintf(buff,"USER    ONLINE: ALL\tCONNECTS  ");
    for (I = 0; I < n_timeperiods; I++){
	if ( isagain(def_tp, I) == 0) {
	    snprintf(tmp_buff, BUF_SIZE, "%s%15s\t  ", buff, def_tp[I].name);
	    strncpy(buff, tmp_buff, BUF_SIZE);

	}
    }
    snprintf(tmp_buff, BUF_SIZE, "%sSUM PRICE  REAL PRICE\n", buff);
    strncpy(buff, tmp_buff, BUF_SIZE);
    prints(buff);
    
    point_user = all_userlist;
	while (point_user != NULL){
		snprintf(buff,BUF_SIZE,"%-8.8s |%-2.2d:%-2.2d  %-5.1ld\t|%ld",
			 point_user->user_name,
			 (point_user->all_time/ 3600),(point_user->all_time/60) % 60,
			 point_user->all_time/60, point_user->all_count);
		sum_price = 0;
		for (I = 0; I < n_timeperiods; I++){
		    if ( isagain(def_tp, I ) == 0) {
			get_tp_data(point_user->tp, I, &ptime, &price);
			sum_price += price;
			snprintf(tmp_buff, BUF_SIZE, "%s\t|%-2.2d:%-2.2d  %-5.1ld %.2f", 
			         buff, ptime/ 3600,(ptime/60) % 60, ptime/60, price);
			strncpy(buff, tmp_buff, BUF_SIZE);

		    }
		}
		if (sum_price+permanent_price < minimum_price){
		    snprintf(tmp_buff, BUF_SIZE, "%s\t|%.2f\t\t|%.2f\n", buff, sum_price, minimum_price);
		} else {
		    snprintf(tmp_buff, BUF_SIZE, "%s\t|%.2f\t\t|%.2f\n", buff, sum_price, sum_price+permanent_price);
		}
		strncpy(buff, tmp_buff, BUF_SIZE);
		prints(buff);        
		point_user=point_user->next;
	}
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print current user name */

void inc_statususer ( char * string, int str_size ){

    if ( str_size == 0){
        prints(user_name);
    } else {
        snprintf(string, str_size,"%s", user_name);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print "from" date*/

void inc_s_longdate ( char * string, int str_size ){
	char buff[BUF_SIZE+1];

    snprintf(buff,BUF_SIZE,"%ld", start_t);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_s_month ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    
    snprintf(buff,BUF_SIZE,"%.2ld", (localtime(&start_t))->tm_mon+1);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_s_day ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    
    snprintf(buff,BUF_SIZE,"%.2ld", (localtime(&start_t))->tm_mday);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_s_hour ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    
    snprintf(buff,BUF_SIZE,"%.2ld", (localtime(&start_t))->tm_hour);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_s_year ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    
    snprintf(buff,BUF_SIZE,"%ld", (localtime(&start_t))->tm_year+1900);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print "to" date*/

void inc_e_longdate ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    snprintf(buff,BUF_SIZE,"%ld", end_t);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_e_month ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    
    snprintf(buff,BUF_SIZE,"%.2ld", (localtime(&end_t))->tm_mon+1);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_e_day ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    
    snprintf(buff,BUF_SIZE,"%.2ld", (localtime(&end_t))->tm_mday);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_e_hour ( char * string, int str_size ){
	char buff[BUF_SIZE+1];
    
    snprintf(buff,BUF_SIZE,"%.2ld", (localtime(&end_t))->tm_hour);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

void inc_e_year ( char * string, int str_size ){
	char buff[BUF_SIZE+1];    
    snprintf(buff,BUF_SIZE,"%ld", (localtime(&end_t))->tm_year+1900);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print "from" date*/

void inc_fromdate ( char * string, int str_size ){

    if ( str_size == 0){
        prints(ctime(&start_t));
    } else {
        snprintf(string, str_size,"%s", ctime(&start_t));
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print "to" date*/

void inc_todate ( char * string, int str_size ){

    if ( str_size == 0){
        prints(ctime(&end_t));
    } else {
        snprintf(string, str_size,"%s", ctime(&end_t));
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print current user statistic */

void inc_statistic ( void ){
     speed_flag++;
     print_time_stat(start_t,end_t,user_name, CMD_USERSTAT);
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_sumhour ( char * string, int str_size ){
	char buff[BUF_SIZE+1];

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }
    snprintf(buff,BUF_SIZE,"%-2.2d:%-2.2d",(all_count / 3600),(all_count/60) % 60);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_summin ( char * string, int str_size ){
	char buff[BUF_SIZE+1];

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }
    snprintf(buff,BUF_SIZE,"%ld",all_count/60);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_tp_sumhour ( char * period_name, char * string, int str_size ){
	char buff[BUF_SIZE+1];
	long all_time;
	float price;

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }

    if (prep_period(post_timeperiods,period_name, &all_time, &price) > 0){
	snprintf(buff,BUF_SIZE,"%-2.2d:%-2.2d",(all_time/3600),(all_time/60) % 60);
	if ( str_size == 0){
    	    prints(buff);
	} else {
    	    snprintf(string, str_size,"%s", buff);
	}
    } else {
	snprintf(buff,BUF_SIZE,"Undefined time period: [%s]", period_name);
	log_info(buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_tp_summin ( char * period_name, char * string, int str_size ){
	char buff[BUF_SIZE+1];
	long all_time;
	float price;

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }

    if (prep_period(post_timeperiods,period_name, &all_time, &price) > 0){
	snprintf(buff,BUF_SIZE,"%ld",all_time/60);
	if ( str_size == 0){
    	    prints(buff);
	} else {
    	    snprintf(string, str_size,"%s", buff);
	}
    } else {
	snprintf(buff,BUF_SIZE,"Undefined time period: [%s]", period_name);
	log_info(buff);
    }
}
/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_tp_rsumhour ( char * period_name, char * string, int str_size ){
	char buff[BUF_SIZE+1];
	long all_time;
	float price;

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }

    if (prep_period(post_timeperiods,period_name, &all_time, &price) > 0){
	snprintf(buff,BUF_SIZE,"%-2.2d:%-2.2d",(all_count -all_time)/ 3600,((all_count -all_time)/60) % 60);
	if ( str_size == 0){
    	    prints(buff);
	} else {
    	    snprintf(string, str_size,"%s", buff);
	}
    } else {
	snprintf(buff,BUF_SIZE,"Undefined time period: [%s]", period_name);
	log_info(buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_tp_rsummin ( char * period_name, char * string, int str_size ){
	char buff[BUF_SIZE+1];
	long all_time;
	float price;

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }

    if (prep_period(post_timeperiods,period_name, &all_time, &price) > 0){
        snprintf(buff,BUF_SIZE,"%ld",(all_count - all_time)/60);
	if ( str_size == 0){
    	    prints(buff);
	} else {
    	    snprintf(string, str_size,"%s", buff);
	}
    } else {
	snprintf(buff,BUF_SIZE,"Undefined time period: [%s]", period_name);
	log_info(buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_tp_price ( char * period_name, char * string, int str_size ){
	char buff[BUF_SIZE+1];
	long all_time;
	float price;

    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }

    if (prep_period(post_timeperiods,period_name, &all_time, &price) > 0){
	snprintf(buff,BUF_SIZE,"%.2f", price);
	if ( str_size == 0){
    	    prints(buff);
	} else {
    	    snprintf(string, str_size,"%s", buff);
	}
    } else {
	snprintf(buff,BUF_SIZE,"Undefined time period: [%s]", period_name);
	log_info(buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_tp_sumprice ( char * string, int str_size ){
        time_period      * pnt_timeperiods;
	int Flag = 0;
	char buff[BUF_SIZE+1];
	float price;
	
    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }

    price = 0;
    pnt_timeperiods = post_timeperiods;
    while (pnt_timeperiods != NULL){
	price += pnt_timeperiods->price * pnt_timeperiods->all_time/60.0;
        pnt_timeperiods=pnt_timeperiods->next;
    } 

    snprintf(buff,BUF_SIZE,"%.2f", price);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_tp_real_sumprice ( char * string, int str_size ){
        time_period      * pnt_timeperiods;
	int Flag = 0;
	char buff[BUF_SIZE+1];
	float price;
	
    if ( speed_flag == 0){
	speed_flag++;
	print_time_stat(start_t, end_t, user_name, CMD_ZERO);
    }

    price = 0;
    pnt_timeperiods = post_timeperiods;
    while (pnt_timeperiods != NULL){
	price += pnt_timeperiods->price * pnt_timeperiods->all_time/60.0;
        pnt_timeperiods=pnt_timeperiods->next;
    } 
    price += permanent_price;
    if (price < minimum_price){
	price = minimum_price;
    }
    snprintf(buff,BUF_SIZE,"%.2f", price);
    if ( str_size == 0){
        prints(buff);
    } else {
        snprintf(string, str_size,"%s", buff);
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print getstatd version */

void inc_version ( void ){
    prints(GETSTATD_VER);
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* Print refresh time */

void inc_refresh ( void ){
	char buff[BUF_SIZE+1];
    snprintf(buff,BUF_SIZE,"%ld", refresh);
    prints(buff);        
}
