/* 
 *  loadform.c - Parse html form with includes.
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include	"getstatd.h"

#define TMP_BUFF_SIZE 4096	

mime_types http_answer[] = {"",
			    "text/html",
			    "text/plain",
			    "image/gif",
			    "image/jpeg",
			    "text/html"};

form_item includes[] = {{"@WHO@",inc_who},
			{"@LINE@",inc_line},
			{"@LAST@",inc_last},
			{"@USERS@",inc_users},
			{"@STATISTIC@",inc_statistic},
			{"@VERSION@",inc_version},
			{"@REFRESH@",inc_refresh},
			{0,0}};

form_item_s includes_s[] = {{"@STATUSER@",inc_statususer},
			{"@FROMDATE@",inc_fromdate},
			{"@S_LONGDATE@",inc_s_longdate},
			{"@TODATA@",inc_todate},
			{"@E_LONGDATE@",inc_e_longdate},
			{"@SUMHOUR@",inc_sumhour},
			{"@SUMMIN@",inc_summin},
			{"@SUMPRICE@",inc_tp_sumprice},
			{"@REAL_SUMPRICE@",inc_tp_real_sumprice},
			{"@S_MONTH@",inc_s_month},
			{"@S_DAY@",inc_s_day},
			{"@S_HOUR@",inc_s_hour},
			{"@S_YEAR@",inc_s_year},
			{"@E_MONTH@",inc_e_month},
			{"@E_DAY@",inc_e_day},
			{"@E_HOUR@",inc_e_hour},
			{"@E_YEAR@",inc_e_year},
			{0,0}};

form_sub_item sub_includes[] = {{"@SUM_SUB_HOUR_",inc_tp_sumhour},
			{"@SUM_SUB_MIN_",inc_tp_summin},
			{"@RSUM_SUB_HOUR_",inc_tp_rsumhour},
			{"@RSUM_SUB_MIN_",inc_tp_rsummin},
			{"@PRICE_",inc_tp_price},
			{"@PLUGINHEADER_",inc_pluginheader},
			{"@PLUGIN_",inc_plugin},
			{0,0}};

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * str_size == 0 - socket output , >0 - strings
 * return: 0 - includes found, 1 - includes not found.
 */

int perform_includes(char * buff, int socket, char * string, int str_size ){
	int I, J, Flag = 0, ExitFlag = 0;
	char	* tmp_buff  = (char *) my_malloc(TMP_BUFF_SIZE+1);
	char	* out_buff;
	char	* old_buff;
	char 	* opp_end;
	int	buff_size;

    if ( str_size != 0){
	    string[0] = '\0';
	    out_buff  = (char *) my_malloc(BUF_SIZE+1);
    }
    strncpy(tmp_buff, buff, TMP_BUFF_SIZE);
    tmp_buff[TMP_BUFF_SIZE] = '\0';
    old_buff = tmp_buff;
    J = 0;
    do {
        for (;( tmp_buff[J] != '\0') && ( tmp_buff[J] != '@'); J++){;}

	if ( tmp_buff[J] != '\0'){

	    if ( str_size == 0){
    		for ( I = 0; includes[I].name != 0; I++){

		    buff_size = strlen(includes[I].name);
		    if (strncasecmp(includes[I].name, tmp_buff+J, buff_size) == 0){
			tmp_buff[J] = '\0';
		    	writeline(socket,tmp_buff);
			(includes[I].parser)();
			
			tmp_buff += buff_size + J;
			J = 0;
			Flag++;
			break;
		    }
    		}
	    }

    	    for ( I = 0; includes_s[I].name != 0; I++){

		    buff_size = strlen(includes_s[I].name);
		    if (strncasecmp(includes_s[I].name, tmp_buff+J, buff_size) == 0){
			tmp_buff[J] = '\0';
			if ( str_size == 0){
		    	    writeline(socket,tmp_buff);
			    (includes_s[I].parser)(NULL, 0);
			} else {
			    strncat(string, tmp_buff, str_size);
			    (includes_s[I].parser)(out_buff, BUF_SIZE);
			    strncat(string, out_buff, str_size);
			}
			tmp_buff += buff_size + J;
			J = 0;
			Flag++;
			break;
		    }
    	    }

    	    for ( I = 0; sub_includes[I].name != 0; I++){
		    
		    buff_size = strlen(sub_includes[I].name);
		    if (strncasecmp(sub_includes[I].name,tmp_buff+J, buff_size ) == 0){

                        opp_end = strchr(tmp_buff+buff_size+J,'@');
			if (opp_end != NULL ){
			    opp_end[0] = '\0';
			    tmp_buff[J] = '\0';

			    if ( str_size == 0){
		    		writeline(socket,tmp_buff);
				(sub_includes[I].parser)(tmp_buff+J+buff_size, NULL, 0);
			    } else {
				strncat(string, tmp_buff, str_size);
				(sub_includes[I].parser)(tmp_buff+J+buff_size,out_buff, BUF_SIZE);
				strncat(string, out_buff, str_size);
			    }
			
			    tmp_buff = opp_end + 1;
			    J = 0;
			} else {
			    log_info("Unbalanced include.");
			}
			Flag++;
			break;
		    }
    	    }
	    J++; 
	} else {
	    ExitFlag = 1;
	}
    } while (ExitFlag == 0);

    if (Flag) {
	if ( str_size == 0){
    	    writeline(socket,tmp_buff);
	} else {
	    strncat(string, tmp_buff, str_size);
	    my_free (out_buff);
	}
	my_free (old_buff);
	return 0;
    } else {
	if ( str_size != 0){
	    my_free (out_buff);
	}
        my_free (old_buff);
	return 1;
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void get_file (int socket, char * path_name, int mime_flag){
       char	* str_buff  = (char *) my_malloc(TMP_BUFF_SIZE+1);
       FILE * index_file;

  if ((index_file = fopen(path_name,"r")) == NULL) {
	log_error("can't open reguested html form.\n");
  }
  snprintf(str_buff, TMP_BUFF_SIZE,"HTTP/1.0 200 OK\nServer: getstatd/%s\nContent-type: %s\n\n" ,GETSTATD_VER, http_answer[mime_flag]);
  writeline(socket, str_buff);

  while ( fgets( str_buff, TMP_BUFF_SIZE, index_file) != NULL ){

      if (mime_flag == MIME_PHTML){
          if ( perform_includes(str_buff,socket, NULL, 0 ) != 0) {
              writeline(socket, str_buff);	  
          }
      } else {
          writeline(socket, str_buff);	  
      }
  }
  fclose(index_file);    
  my_free(str_buff);
}
