/* 
 *  plugins.c - External plug-ins.
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include "getstatd.h"

/*  char * name;
    char * iostdin;
    char * proc;
    char * header;
    struct _PLUGIN_LIST_ * next;
*/
/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
void inc_pluginheader ( char * name, char * string, int str_size ){
        plugin_list      * pnt_plugins;
	char * buff = (char*) my_malloc(BUF_SIZE*10+1);

    if (str_size != 0){
	string[0]='\0';
	my_free(buff);
	return;
    }

    pnt_plugins = post_plugins;
    while (pnt_plugins != NULL){

	if (strcmp( name, pnt_plugins->name) == 0){
	    if ( perform_includes(pnt_plugins->header,0, buff, BUF_SIZE*10 ) != 0) {
		prints(pnt_plugins->header);
	    } else {
		prints(buff);
	    }
	}
        pnt_plugins=pnt_plugins->next;
    } 
    my_free(buff);
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void inc_plugin ( char * name,char * string, int str_size ){
        plugin_list      * pnt_plugins;
	char * buff;
	char * buff_cmd = (char*) my_malloc(BUF_SIZE*10+1);
	char * buff_stdin = (char*) my_malloc(BUF_SIZE*10+1);
	FILE * pfd;
	int	read_cnt;
	int fifo[2];

    pnt_plugins = post_plugins;
    while (pnt_plugins != NULL){

	if (strcmp( name, pnt_plugins->name) == 0){
	    if ( perform_includes(pnt_plugins->proc,0, buff_cmd, BUF_SIZE*10 ) != 0) {
		strncpy(buff_cmd, pnt_plugins->proc,BUF_SIZE*10);
		buff_cmd[BUF_SIZE*10]= '\0';
	    } 
	    if (pipe(fifo) == -1){
	        log_info("Can't create pipe.");
	        my_free(buff_stdin);
	        my_free(buff_cmd);
	        return;
	    }
	    dup2(fifo[0],STDIN_FILENO);

	    if ((pnt_plugins->iostdin[0] != 0)&&(pnt_plugins->iostdin[0] != '*')){

    		if (fork() == 0){
	    	    close(fifo[0]);
		    use_ssl = 0;
		    gen_socket = fifo[1];

        	    if ( perform_includes(pnt_plugins->iostdin, fifo[1], NULL, 0 ) != 0) {
			writeline(fifo[1], pnt_plugins->iostdin);	  
            	    }
		    close(fifo[1]);		    
		    exit(0);
		}
	    }
    	    close(fifo[1]);		    
	    
	    if ((pfd = popen(buff_cmd,"r")) == NULL){
		log_info("Can't open pipe. Check plugin record.");
		my_free(buff_stdin);
		my_free(buff_cmd);
		return;
	    }

	    if (str_size == 0){
		buff = my_malloc(BUF_SIZE+2);
		while (read_cnt = fread(buff, 1, BUF_SIZE, pfd)){
		    buff[read_cnt] = '\0';
		    prints(buff);
		}
		my_free(buff);
    	    } else {
		read_cnt = fread(string, 1, str_size, pfd);
		string[read_cnt-1]='\0';
	    }
	    close(fifo[0]);
	    pclose(pfd);	    
	}
        pnt_plugins=pnt_plugins->next;
    } 
    my_free(buff_stdin);
    my_free(buff_cmd);
}
