/* 
 *  print_stat.c - Prepare user statistic. 
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include "getstatd.h"

long all_count, line_count, all_night;
user_list ** cur_next_user;
user_list *  all_userlist;
tty_list  ** cur_next_tty;
tty_list  *  all_ttylist;
int	     wtmp_arc_cnt;
simple_time_period * def_tp;

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

int list_line( def_utmp *p, time_t t, int what, time_t start_date, 
			    time_t end_date, char * user_name, int cmd_flag){

        char * logintime;
        char * logouttime;
        char * length;
        char * buff;
        time_t secs, tmp, from_night, end_night, tmp_night;
        int mins, hours, Flag = 0, line_in_use;
	str_array * str_pnt;    	
	ignore_list * ignore_pnt;    	
	user_list * point_user;
	tty_list * point_tty;
	char	* newstr;
        time_period      * pnt_timeperiods;
	int I = 0;
#ifdef HAVE_ADDR_IN_UTMP
	struct in_addr real_ip;
#endif

/* Check user name if generating current user statistic */
  if ((strncasecmp(p->ut_name, user_name, UT_NAMESIZE ) != 0)&&
                                     (( cmd_flag == CMD_USERSTAT)||(( cmd_flag == CMD_ZERO)))){ 
	return 0; 
  }

/* Check valid terminal */

  if ( check_tty(p->ut_line) != 0 ){
     return 0;
  }

/* Compare user name with ignorelist */
    ignore_pnt = ignore_userlist;
    while (ignore_pnt != NULL){
        if (strncasecmp(p->ut_name, ignore_pnt->user_name, UT_NAMESIZE) == 0){
        	Flag = 1;
        }
	ignore_pnt=ignore_pnt->next;
    } 
    if ( (invertignoreusers == 0)&&(Flag == 1)){
	return 0;
    }
    if ( (invertignoreusers == 1)&&(Flag == 0)){
	return 0;
    }

  buff = (char *) my_malloc(BUF_SIZE+1);
  length = (char *) my_malloc(TIME_SIZE+1);
  logouttime = (char *) my_malloc(TIME_SIZE+1);
  logintime = (char *) my_malloc(TIME_SIZE+1);


/* Calculate times */

  tmp = (time_t) p->ut_time;
  strncpy(logintime, ctime(&tmp), TIME_SIZE);
  logintime[TIME_SIZE] = '\0';
  snprintf( logouttime, TIME_SIZE, "%s", ctime(&t));
  secs = t - p->ut_time;
  mins   = (secs / 60)%60;
  hours = (secs / 3600);
  snprintf(length, TIME_SIZE, "%02d:%02d", hours, mins);

/* Check login status */
  switch(what) {
	case R_DOWN:
	case R_REBOOT:
		    my_free(logintime);
		    my_free(logouttime);
		    my_free(length);
		    my_free(buff);
		    return 0;	
	case R_NOW:
	case R_CRASH:
        case R_NORMAL:
		break;
  }

  if ( (p->ut_time >= start_date) && ((p->ut_time <= end_date))){

        all_count += secs;

	pnt_timeperiods = post_timeperiods;
	while (pnt_timeperiods != NULL){
	    tmp_night = pnt_timeperiods->period*60*60*(secs/(60*60*24)+1);
	    from_night = make_utc_time ( p->ut_time, pnt_timeperiods->base_hour, pnt_timeperiods->period);
	    end_night = from_night + pnt_timeperiods->period*60*60;

	    if ( p->ut_time > from_night) {
                 tmp_night -= p->ut_time - from_night;
	    }

	    if ( t < end_night) {
                 tmp_night -= end_night - t;
	    }

	    if ((p->ut_time >= end_night) || ( t <= from_night)) {
		tmp_night = 0;
	    }
	    pnt_timeperiods->all_time += tmp_night;
	    def_tp[I++].all_time = tmp_night;
	    pnt_timeperiods=pnt_timeperiods->next;
	} 

	if ( cmd_flag == CMD_USERSTAT){
    	    if (line_count/2 == line_count/2.0){ 	
    		prints(NONEVENTR);
		prints("<TD>&nbsp;");
		/* d11 Online time */
        	snprintf(buff,TIME_SIZE,"%s (%ld)",length,secs/60);
  		prints(buff);        
		prints("</TD>");
		prints("<TD>&nbsp;");
    		/* d12 Connect. */
  		prints(p->ut_host);        
		prints("</TD>");
		prints("<TD>&nbsp;");
    		/* d13 Link up, time (h:m) */
  		prints(logintime);        
		prints("</TD>");
		prints("<TD>&nbsp;");
    		/* d14 Link down, time (h:m) */
  		prints(logouttime);        
		prints("</TD>");
		prints("</TR>");
		line_count++;
	    } else {
		prints(EVENTR);
		prints("<TD>&nbsp;");
    		/* d11 Online time */
        	snprintf(buff,TIME_SIZE,"%s (%ld)",length,secs/60);
  		prints(buff);        
		prints("</TD>");
		prints("<TD>&nbsp;");
    		/* d12 Connect. */
  		prints(p->ut_host);        
		prints("</TD>");
		prints("<TD>&nbsp;");
    		/* d13 Link up, time (h:m) */
  		prints(logintime);        
		prints("</TD>");
		prints("<TD>&nbsp;");
    		/* d14 Link down, time (h:m) */
  		prints(logouttime);        
		prints("</TD>");
	        prints("</TR>");
		line_count++;
	    }
	}

	if ( (cmd_flag == CMD_LASTSTAT) && (line_count < 500)){
		logintime[strlen(logintime)-1]='\0';
#ifdef HAVE_ADDR_IN_UTMP
		real_ip.s_addr = p->ut_addr;
	    	snprintf(buff,BUF_SIZE,"%-3.3d, %-8.8s  %-8.8s   %s (%ld) %-16.16s\t%-15.15s  %s - %s",line_count,p->ut_name,p->ut_line,length,secs/60,p->ut_host,inet_ntoa(real_ip),logintime,logouttime);
#else
	    	snprintf(buff,BUF_SIZE,"%-3.3d, %-8.8s  %-8.8s   %s (%ld)\t%-16.16s\t%s - %s",line_count,p->ut_name,p->ut_line,length,secs/60,p->ut_host,logintime,logouttime);
#endif
  		prints(buff);        
		line_count++;
	}
	
	if ( (cmd_flag == CMD_ALLUSERSTAT) || (cmd_flag == CMD_LASTSTAT) || 
	     (cmd_flag == CMD_USERSTAT) || (cmd_flag == CMD_ZERO) || 
	                                      (cmd_flag == CMD_LINESTAT)){
	    Flag = 0;
	    point_user = all_userlist;
	    while (point_user != NULL){
    		if (strncasecmp(p->ut_name, point_user->user_name, UT_NAMESIZE) == 0){
                     Flag = 1;
		     (point_user->all_count)++;
		     point_user->all_time += secs;
		     for (I = 0; I < n_timeperiods; I++){
		         point_user->tp[I].all_time += def_tp[I].all_time; 
		     }
		}
		point_user=point_user->next;
	    } 

	    if (Flag == 0){
		newstr = (char *) my_malloc(UT_NAMESIZE+1);
    		strncpy(newstr,p->ut_name,UT_NAMESIZE);
		newstr[UT_NAMESIZE] = '\0';
    		point_user = (user_list *) my_malloc(sizeof( user_list ));
    		point_user->user_name = newstr;
		point_user->all_count = 1;
		point_user->all_time = secs;
		point_user->tp = (simple_time_period *) my_malloc(sizeof(simple_time_period) * n_timeperiods);
		memcpy(point_user->tp, def_tp, sizeof(simple_time_period) * n_timeperiods);
    		point_user->next = NULL;
    		*cur_next_user = point_user;
    		cur_next_user = &(point_user->next);
	    }

	}

	if ( (cmd_flag == CMD_LINESTAT)||(cmd_flag == CMD_LASTSTAT)||
	     (cmd_flag == CMD_USERSTAT) || (cmd_flag == CMD_ZERO) || 
					(cmd_flag == CMD_ALLUSERSTAT)){
	    point_tty = all_ttylist;
	    line_in_use =1;
	    Flag = 0;

	    while (point_tty != NULL){

    		if (strncmp(p->ut_line, point_tty->tty_name, UT_LINESIZE ) == 0){
		     Flag = 1;
		     (point_tty->all_count)++;
		     point_tty->all_time += secs;
		     for (I = 0; I < n_timeperiods; I++){
		         point_tty->tp[I].all_time += def_tp[I].all_time; 
		     }
		     point_tty->begin_time = p->ut_time;
		     point_tty->end_time = t;
    		}

		if ((point_tty->begin_time > p->ut_time)||(point_tty->end_time < t)){

		    if (( point_tty->begin_time < t) && ( point_tty->end_time > p->ut_time)) { 
    			line_in_use++;
		    }
		}
		point_tty=point_tty->next;
	    }
	    if (line_in_use-1 < TERM_SIZE){
		   coop_tty[line_in_use-1]++;
	    }

	    if (Flag == 0){
    		newstr = (char *) my_malloc(UT_LINESIZE+1);
    		strncpy(newstr, p->ut_line, UT_LINESIZE);
		newstr[UT_LINESIZE] = '\0';
    		point_tty = (tty_list *) my_malloc(sizeof( tty_list ));
    		point_tty->tty_name = newstr;
		point_tty->all_count = 1;
		point_tty->all_time = secs;
		point_tty->tp = (simple_time_period *) my_malloc(sizeof(simple_time_period) * n_timeperiods);
		memcpy(point_tty->tp, def_tp, sizeof(simple_time_period) * n_timeperiods);
		point_tty->begin_time = 0;
		point_tty->end_time = 0;
    		point_tty->next = NULL;
    		*cur_next_tty = point_tty;
    		cur_next_tty = &(point_tty->next);
		str_pnt=str_pnt->next;
	    }
	}
  }
  my_free(logintime);
  my_free(logouttime);
  my_free(length);
  my_free(buff);
  return 0;
}
/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

FILE * open_wtmp_arc(int arc_num){
	char real_path[BUF_SIZE+1];
	char tmp_path[BUF_SIZE+1];
	char pipe_cmd[BUF_SIZE*2+1];
	char *buff;
	char *num_ptr;
	FILE * tmp_file;
	FILE * pipe_file;
	int	tmp_cnt;

    if ( wtmp_arc_mask == NULL ){
	return NULL;
    }
    if ((num_ptr = strchr(wtmp_arc_mask,'*')) == NULL){
	if ( arc_num != 0 ){
	    return NULL;
	}	
	strncpy(real_path, wtmp_arc_mask, BUF_SIZE);
	
    } else {
	strncpy(real_path, wtmp_arc_mask, BUF_SIZE);
	real_path[num_ptr - wtmp_arc_mask] = '\0';
	snprintf(tmp_path, BUF_SIZE,"%s%d%s",real_path, arc_num, num_ptr+1);
	strncpy(real_path, tmp_path, BUF_SIZE);
    }

    if ( wtmp_arc_expand == NULL ){
	if ((tmp_file = fopen(real_path, "r")) == NULL){
	    return NULL;
	}
	return tmp_file;
    } else {
	snprintf(pipe_cmd, BUF_SIZE*2,"%s %s", wtmp_arc_expand, real_path);
	if (access(real_path, R_OK) == 0){
	    if ((tmp_file = tmpfile()) == NULL){
		log_info("Can't create temp file.");
		return NULL;
	    }
	    if ((pipe_file = popen(pipe_cmd, "r"))==NULL){
		log_info("Can't open unpacker.");
		fclose(tmp_file);
		return NULL;
	    }

	    buff = my_malloc(sizeof(def_utmp)*512);
	    while (tmp_cnt = fread(buff, sizeof(def_utmp), 512, pipe_file)){
		fwrite(buff, sizeof(def_utmp), tmp_cnt, tmp_file);
	    }
	    my_free(buff);
	    
    	    pclose(pipe_file);	    
	    return tmp_file;
	} else {
	    return NULL;
	}
    }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
time_t get_wtmp_date(int arc_num){
	char real_path[BUF_SIZE+1];
	char tmp_path[BUF_SIZE+1];
	char *num_ptr;
	struct stat f_stat;

    if ( wtmp_arc_mask == NULL ){
	return -1;
    }
    if ((num_ptr = strchr(wtmp_arc_mask,'*')) == NULL){
	strncpy(real_path, wtmp_arc_mask, BUF_SIZE);
    } else {
	strncpy(real_path, wtmp_arc_mask, BUF_SIZE);
	real_path[num_ptr - wtmp_arc_mask] = '\0';
	snprintf(tmp_path, BUF_SIZE,"%s%d%s",real_path, arc_num, num_ptr+1);
	strncpy(real_path, tmp_path, BUF_SIZE);
    }

    if ( stat(real_path, &f_stat) == -1){
	return -1;
    }
    return f_stat.st_mtime;
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

FILE * set_first_position(time_t start_date, time_t end_date){
          time_t begintime;
          def_utmp ut;
          FILE *fp;	
	  time_t begin_arc, end_arc;
          struct stat st;

    wtmp_arc_cnt = 0;

    if ((fp = fopen(wtmp_path, "r")) == NULL) {
	log_error ("Can't open wtmp file.");
    }

    if (fread(&ut, sizeof(def_utmp), 1, fp) == 1){
	begintime = ut.ut_time;
    } else {
  	fstat(fileno(fp), &st);
	begintime = st.st_ctime;
    }

    if (start_date >= begintime){
	wtmp_arc_cnt = -1;
    }

    if (end_date >= begintime){
	fseek(fp, -1L * sizeof(def_utmp), SEEK_END);
    } else {
	if (fp != NULL){
	    fclose(fp);
	}
	wtmp_arc_cnt++;
	
	if (get_wtmp_date(wtmp_arc_cnt-1) == -1){
	    wtmp_arc_cnt++;
	}
	do {
	    begin_arc = get_wtmp_date(wtmp_arc_cnt-1);
	    end_arc = get_wtmp_date(wtmp_arc_cnt);
	    wtmp_arc_cnt++;
	} while ((end_arc != -1)&&(!((end_date >= end_arc)&&(start_date <= begin_arc))));
	
	if ((fp = open_wtmp_arc(wtmp_arc_cnt-2)) == NULL) {
	    return NULL;
	}
	fseek(fp, -1L * sizeof(def_utmp), SEEK_END);
    }
    return fp;
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

int read_wtmp_block (void *ptr, FILE **pfp, time_t start_date, time_t end_date, int action){
	  time_t begin_arc, end_arc;
	  int flag = 0;


    if(action == 0){
	if ( fread(ptr,  sizeof(def_utmp), 1, *pfp) == 0){
	    flag++;
	}
    } else {
	if (fseek(*pfp, -2 * sizeof(def_utmp), SEEK_CUR) < 0){
	    flag++;
	}	  
    }
    if (flag == 0){
	return 1;
    }

    if (wtmp_arc_cnt == 0){
	if (*pfp != NULL){
	    fclose(*pfp);
	}
	wtmp_arc_cnt++;
	
	if (get_wtmp_date(wtmp_arc_cnt-1) == -1){
	    wtmp_arc_cnt++;
	}
    } else {
	if (*pfp != NULL){
	    fclose(*pfp);
	}
    }
    do {
        begin_arc = get_wtmp_date(wtmp_arc_cnt-1);
        end_arc = get_wtmp_date(wtmp_arc_cnt);
	wtmp_arc_cnt++;
    } while ((end_arc != -1)&&(!((end_date >= end_arc)&&(start_date <= begin_arc))));

    if ((*pfp = open_wtmp_arc(wtmp_arc_cnt-2)) == NULL) {
        return 0;
    }
    fseek(*pfp, -1L * sizeof(def_utmp), SEEK_END);
    return read_wtmp_block(ptr, pfp, start_date, end_date, action);
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
 /* Portions from "last" */
 
int print_time_stat (time_t start_date, time_t end_date, char * user_name, int cmd_flag){
          FILE *fp;	
          def_utmp ut;
          utmp_list * utmplist = NULL;
          utmp_list *p;	
          utmp_list *temp_p;	
          utmp_list *next;
          time_t lastboot = 0; 
          time_t lastrch = 0;	
          time_t lastdown;
          int whydown = 0;
	  int I=0;
          int quit = 0;
          int lastb = 0;
          int down;
          time_period      * pnt_timeperiods;
	  time_t	saved_time = 0;
	  time_t	temp_saved_time;

    all_userlist = NULL;
    cur_next_user = &(all_userlist);
    all_ttylist = NULL;
    cur_next_tty = &(all_ttylist);
    all_count =0;
    all_night =0;
    line_count =0;

    def_tp = (simple_time_period *) my_malloc(sizeof(simple_time_period) * n_timeperiods);
    pnt_timeperiods = post_timeperiods;
    while (pnt_timeperiods != NULL){
	strncpy(def_tp[I].name, pnt_timeperiods->name, PN_SIZE);
	def_tp[I].price = pnt_timeperiods->price;
	I++;
        pnt_timeperiods=pnt_timeperiods->next;
    } 

    if (start_date >= end_date){
	return -1;
    }

    if ((fp=set_first_position(start_date, end_date)) == NULL){
	return -1;
    }

  /* Read struct after struct */
    while(read_wtmp_block(&ut, &fp, start_date, end_date, 0)) {

	if (lastb){
		quit = list_line(&ut, ut.ut_time, R_NORMAL,start_date,end_date,user_name, cmd_flag);
	} else {
	        down = 0;

	        if (strncmp(ut.ut_line, "~", 1) == 0) {
		/* Halt/reboot/shutdown etc */

		    if (strncmp(ut.ut_name, "shutdown", 8) == 0) {
			lastdown = lastrch = ut.ut_time;
			down = 1;
		    }

		    if (strncmp(ut.ut_name, "reboot", 6) == 0) {
			strncpy(ut.ut_line, "system boot", UT_LINESIZE);
			quit = list_line(&ut, lastdown, R_REBOOT, start_date, end_date, user_name, cmd_flag);
			lastdown = ut.ut_time;
			down = 1;
		    }

		    if (strncmp(ut.ut_name, "runlevel", 7) == 0) {
			down = 1;
			lastrch = ut.ut_time;
		    }

		    if (down) {
			lastboot = ut.ut_time;
			whydown = R_CRASH;

			/* Delete the list; it's meaningless now */
			for(p = utmplist; p; p = next) {
				next = p->next;
				my_free(p);
			}
			utmplist = NULL;
			saved_time = 0;
		    }

	        } else {
		/* Allright, is this a login or a logout? */

		if (ut.ut_name[0] != 0 && strcmp(ut.ut_name, "LOGIN")) {
			/* This is a login */
			/* Walk through list to see when logged out */
			temp_p = NULL;
			temp_saved_time = 0;
			for(p = utmplist; p; p = next) {
				next = p->next;
				if (((strncmp(p->ut.ut_line, ut.ut_line, UT_LINESIZE) == 0)&&(temp_p != NULL))||(p->ut.ut_line[0] == 0)){
					/* Remove addition entry */

					if (p->next){
					    p->next->prev = p->prev;
					}

					if (p->prev){
						p->prev->next = p->next;
					} else {
						utmplist = p->next;
					}
					my_free( p );
					continue;

				} 
 				if ((strncmp(p->ut.ut_line, ut.ut_line, UT_LINESIZE) == 0)&&(temp_p==NULL)){
					    /* Show it */
					    quit = list_line(&ut, p->ut.ut_time, R_NORMAL,start_date,end_date,user_name, cmd_flag);
					    /* Delete it from the list */

					    if (p->next){
						p->next->prev = p->prev;
					    }

					    if (p->prev){
					    	p->prev->next = p->next;
					    } else {
						utmplist = p->next;
					    }
					    temp_p = p;

					    if (p->ut.ut_time == saved_time){
						saved_time = 0;
					    }
					} else {
					    if (p->ut.ut_time > temp_saved_time){
    						temp_saved_time = p->ut.ut_time;
					}
				}
			}
			if (saved_time < temp_saved_time){
			    saved_time = temp_saved_time;
			}			
			my_free( temp_p );
			/* Not found? Then crashed, down or still logged in */
			if (temp_p == NULL){
				if (lastboot == 0){
					quit = list_line(&ut, time(NULL), R_NOW,start_date,end_date,user_name, cmd_flag);
				} else {
					quit = list_line(&ut, lastboot, whydown,start_date,end_date,user_name, cmd_flag);
				}
			}
		}
		/* Get some memory */
		p = (utmp_list *) my_malloc(sizeof(utmp_list));
		/* Fill in structure */
		memcpy(&p->ut, &ut, sizeof(def_utmp));
		p->next  = utmplist;
		p->prev  = NULL;

		if (saved_time == 0){
		    saved_time = ut.ut_time;
		}
		if (utmplist){
		    utmplist->prev = p;
	 	}
		utmplist = p;		
	  }
      }
      if ((saved_time < start_date)&&(ut.ut_time < start_date)){
	    break;
      }
      if ( read_wtmp_block(&ut, &fp, start_date, end_date, 1) != 1){
          break;
      }	  
  }
    if (fp != NULL){
        fclose(fp);
    }
}
