/* 
 *  pwdcheck.c - Identificate the user password and check his rights. 
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include "getstatd.h"

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
 
int pwdcheck (int isauth){
	char * user_id;
	char * user;
	char * passwd;
	char * cl_query = (char *) my_malloc (BUF_SIZE*10+1);
	char * buff =(char *) my_malloc (BUF_SIZE+1);
#define AUTH_SIZE 21 
	int dsize, flag = 0;

    while((dsize = readline(gen_socket,cl_query,BUF_SIZE*10)) > 2){
    	cl_query[dsize] = '\0';
	if ( strstr( cl_query, "Authorization: Basic ") != NULL){
	    flag = 1;
	    user_id = cl_query + AUTH_SIZE;
	    break;
        }
    }

    if ( (flag == 0)||(isauth != 0)){
	    get_auth();
	    my_free(buff);
	    my_free(cl_query);
    	    return -1;
    }

    mark_first_word(user_id);
    user = uudecode(user_id);
    if ( (passwd = strchr(user, ':')) == NULL){
	    my_free(buff);
	    my_free(cl_query);
    	    return -1;
    }
    passwd[0] = '\0';
    passwd++;
    
    
    flag = check_local_pwd(user, passwd);
    if (flag == -1) {
	flag = check_pop_pwd(user, passwd);
    }
    strncpy(user_name, user, BUF_SIZE);
    user_name[BUF_SIZE] = '\0';
    fill_null( user );
    fill_null( passwd );
    my_free (user);

    if (flag != 0){
	snprintf (buff, BUF_SIZE, "Identification error, wrong user [%s][%s]", user_name, gen_ipaddr);
	log_info(buff);
    }
    my_free(buff);
    my_free(cl_query);
    return flag;
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

int usercheck( char * username, int usertype ){
	FILE * listfile;
	char * cur_user;
	char * buff;
	char * str_ptr;
	int  exist_ret=0, notexist_ret=-1;

    switch ( usertype ){
	case UT_USER:
		    listfile = fopen(userlist, "r");
		    if (invertuserlist == 1){
			exist_ret=-1;
			notexist_ret=0;
		    }
		    break;
	case UT_ADMIN:
		    listfile = fopen(adminlist, "r");
		    if (invertadminlist == 1){
			exist_ret=-1;
			notexist_ret=0;
		    }
		    break;
	case UT_PLUGIN:
		    listfile = fopen(pluginlist, "r");
		    if (invertpluginlist == 1){
			exist_ret=-1;
			notexist_ret=0;
		    }
		    break;
	default:
		    log_info("Unrecognized user type.");
		    return -1;
		    break;    
    }

    if ( listfile == NULL) {
	log_info("Can't open list file.");
	return -1;
    }
    cur_user = (char *) my_malloc(BUF_SIZE+1);
    buff = (char *) my_malloc(BUF_SIZE+1);
    
    while ( fgets( cur_user, BUF_SIZE, listfile) != NULL ){

	str_ptr = strpbrk(cur_user, DILIMERS);

	if (str_ptr != NULL){
	    str_ptr[0] = '\0';
	}

	if (strcasecmp(cur_user, username ) == 0){
	    fclose(listfile);
            my_free(buff);
	    my_free(cur_user);
	    return exist_ret;
	}

	if (strncmp(cur_user,"*",1) == 0){
	    fclose(listfile);
            my_free(buff);
	    my_free(cur_user);
	    return exist_ret;
	}
    
    }

    snprintf (buff, BUF_SIZE, "User [%s][%s] not allowed for this operation.", user_name, gen_ipaddr);
    log_info(buff);
    fclose(listfile);
    my_free(buff);
    my_free(cur_user);
    return notexist_ret;
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void get_auth(){

    prints( "HTTP/1.0 401 Unauthorithed\n");
    prints( "WWW-Authenticate: Basic realm=\"Authorithed user\"\n");
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */
/* 
 * Check valid ip addreess. Return 0 - allow, -1 - deny.
 * service_flag:
 * #define UT_MAIN 		0 - Index request  
 * #define UT_USER 		1 - Current user statistic 
 * #define UT_ADMIN 		2 - Admin statistic 
 * #define UT_PLUGIN 		3 - Plugin statistic 
 *
 * "A" - admins.
 * "P" - plugins.
 * "U" - users.
 * "*" - deny for for users, plugins and admins.
 * "!" - deny connections from this host.
 * ""  - allow for users, plugins and admins.
 *
 */

int check_host(unsigned long int addr, int service_flag){
	p_hosts_allow * str_pnt;
	char * sub_str;
	unsigned long int netnumber;
	unsigned long int netmask;

    str_pnt = post_hostsallow;
    while (str_pnt != NULL){
        if ((addr & str_pnt->netmask) == str_pnt->netaddr){
		switch(service_flag){
		    case UT_MAIN:
			    if (str_pnt->flag_close == 1){
			        log_ip_deny(addr);
				return 1;
			    }
		    case UT_USER:
			    if (((str_pnt->flag_users == 1)||
			       (str_pnt->flag_all == 1))&&
			       ((str_pnt->flag_deny == 0)&&
			       (str_pnt->flag_close == 0))){
				return 0;
			    } else {
			        log_ip_deny(addr);
				return 1;
			    }
		    case UT_ADMIN:
			    if (((str_pnt->flag_admin == 1)||
			       (str_pnt->flag_all == 1))&&
			       ((str_pnt->flag_deny == 0)&&
			       (str_pnt->flag_close == 0))){
				return 0;
			    } else {
			        log_ip_deny(addr);
				return 1;
			    }
		    case UT_PLUGIN:
			    if (((str_pnt->flag_plugin == 1)||
			       (str_pnt->flag_all == 1))&&
			       ((str_pnt->flag_deny == 0)&&
			       (str_pnt->flag_close == 0))){
				return 0;
			    } else {
			        log_ip_deny(addr);
				return 1;
			    }
		}
	}
	str_pnt=str_pnt->next;
    } 
    log_ip_deny(addr);
    return -1;
}
