/* 
 *  ssl.c - SSL protocol implementation.
 *
 *  Copyright (c) 1998  Maxim Chirkov <mc@skyway.ru>  
 */

#include	"getstatd.h"

#ifndef NOSSL

SSL 		* ssl_socket;
SSL_CTX 	* ssl_ctx;
X509 		* public_cert;
RSA 		* private_key;

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void ssl_setup(int sockfd){
	    int  serial;
	    
      ssl_socket=(SSL *)SSL_new(ssl_ctx);
      SSL_set_fd(ssl_socket, sockfd);
//      SSL_set_fd(ssl_socket,fileno(stdout));

      if (SSL_use_RSAPrivateKey(ssl_socket, private_key)==0)  {
      	log_error("Error reading Private Key, SSL disabled.");
      }

      if (SSL_use_certificate(ssl_socket,public_cert)==0) {
        log_error("Error reading certificate, SSL disabled.");
      }

      if (SSL_accept(ssl_socket)<=0)  {
	log_error ("SSL Access failed");
      }
}

/*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

void ssl_init(){
	FILE *fp;

	SSLeay_add_ssl_algorithms();

        ssl_ctx=(SSL_CTX *)SSL_CTX_new(SSLv23_server_method());

        fp=fopen(ssl_certificate,"r");
        if (fp==NULL)  {
	    use_ssl == 0;
	    log_info("SSL disabled: certificate not found.");
	    return;
        }

        public_cert=X509_new();

        if (PEM_read_X509(fp,&public_cert,NULL)==0)  {
	    use_ssl == 0;
	    log_info("SSL disabled: certificate reading error.");
	    return;
        }
        fclose(fp);

        fp=fopen(ssl_key,"r");
        if (fp==NULL)  {
	    use_ssl == 0;
	    log_info("SSL disabled: key not found.");
	    return;
        }
        private_key=RSA_new();
        if (PEM_read_RSAPrivateKey(fp,&private_key,NULL)==0)  {
	    use_ssl == 0;
	    log_info("SSL disabled: key reding error.");
	    return;
        }
        fclose(fp);
}

#endif